﻿using System;
using System.Windows.Input;

namespace FSNCleaner.Silverlight
{
    public class CleanFileAllCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public CleanFileAllCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }
        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.CleanFileAll();
        }
    }

    public class CleanFileWrapCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public CleanFileWrapCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.CleanFileWrap();
        }
    }

    public class CleanFileLRCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public CleanFileLRCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.CleanFileLR();
        }
    }

    public class CleanFileVoicesCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public CleanFileVoicesCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.CleanFileVoices();
        }
    }

    public class CleanFileCommentCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public CleanFileCommentCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.CleanFileComment();
        }
    }

    public class AddWordWrapCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public AddWordWrapCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.AddWordWrap();
        }
    }

    public class AddLRCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public AddLRCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.AddLR();
        }
    }

    public class AddBlankSpaceCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public AddBlankSpaceCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.AddBlankSpace();
        }
    }

    public class ReplaceDoubleQuoteCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public ReplaceDoubleQuoteCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.ReplaceDoubleQuote();
        }
    }

    public class ScriptFileCommand : ICommand
    {
        private readonly MainPageViewModel _vm;

        public ScriptFileCommand(MainPageViewModel vm)
        {
            _vm = vm;
        }

        public bool CanExecute(object parameter)
        {
            return _vm.CurrentFile != null;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _vm.ScriptFile();
        }
    }
}
